"use strict";
function tagParameter(target, targetKey, index, metadata) {
    var metadataKey = "inversify:tagged";
    var paramsMetadata = null;
    if (targetKey !== undefined) {
        var msg = "The @tagged and @named decorator must be applied to the parameters of a constructor.";
        throw new Error(msg);
    }
    if (Reflect.hasOwnMetadata(metadataKey, target) !== true) {
        paramsMetadata = {};
    }
    else {
        paramsMetadata = Reflect.getMetadata(metadataKey, target);
    }
    var paramMetadata = paramsMetadata[index.toString()];
    if (Array.isArray(paramMetadata) !== true) {
        paramMetadata = [];
    }
    else {
        for (var i = 0; i < paramMetadata.length; i++) {
            var m = paramMetadata[i];
            if (m.key === metadata.key) {
                throw new Error("Metadadata key " + m.key + " was used more than once in a parameter.");
            }
        }
    }
    paramMetadata.push(metadata);
    paramsMetadata[index.toString()] = paramMetadata;
    Reflect.defineMetadata(metadataKey, paramsMetadata, target);
    return target;
}
exports.tagParameter = tagParameter;
function _decorate(decorators, target) {
    Reflect.decorate(decorators, target);
}
function _param(paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); };
}
function decorate(decorator, target, parameterIndex) {
    if (typeof parameterIndex === "number") {
        _decorate([_param(parameterIndex, decorator)], target);
    }
    else {
        _decorate([decorator], target);
    }
}
exports.decorate = decorate;
