"use strict";
var METADATA_KEY = require("../constants/metadata_keys");
var ERRORS_MSGS = require("../constants/error_msgs");
function Inject() {
    var paramTypes = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        paramTypes[_i - 0] = arguments[_i];
    }
    return function (target) {
        if (Reflect.hasOwnMetadata(METADATA_KEY.INJECT, target) === true) {
            throw new Error(ERRORS_MSGS.DUPLICATED_INJECT_DECORATOR);
        }
        Reflect.defineMetadata(METADATA_KEY.INJECT, paramTypes, target);
        return target;
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Inject;
