"use strict";
var METADATA_KEY = require("../constants/metadata_keys");
var ERRORS_MSGS = require("../constants/error_msgs");
function ParamNames() {
    var paramNames = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        paramNames[_i - 0] = arguments[_i];
    }
    return function (target) {
        if (Reflect.hasOwnMetadata(METADATA_KEY.PARAM_NAMES, target) === true) {
            throw new Error(ERRORS_MSGS.DUPLICATED_PARAM_NAMES_DECORATOR);
        }
        Reflect.defineMetadata(METADATA_KEY.PARAM_NAMES, paramNames, target);
        return target;
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = ParamNames;
