"use strict";
var Request = (function () {
    function Request(service, parentContext, parentRequest, bindings, target) {
        if (target === void 0) { target = null; }
        this.guid = this._guid();
        this.service = service;
        this.parentContext = parentContext;
        this.parentRequest = parentRequest;
        this.target = target;
        this.childRequests = [];
        this.bindings = (Array.isArray(bindings) ? bindings : ((bindings) ? [bindings] : []));
    }
    Request.prototype.addChildRequest = function (service, bindings, target) {
        var child = new Request(service, this.parentContext, this, bindings, target);
        this.childRequests.push(child);
        return child;
    };
    Request.prototype._s4 = function () {
        return Math.floor((1 + Math.random()) * 0x10000)
            .toString(16)
            .substring(1);
    };
    Request.prototype._guid = function () {
        return this._s4() + this._s4() + "-" + this._s4() + "-" + this._s4() + "-" +
            this._s4() + "-" + this._s4() + this._s4() + this._s4();
    };
    return Request;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Request;
