"use strict";
var metadata_1 = require("../activation/metadata");
var queryable_string_1 = require("./queryable_string");
var Target = (function () {
    function Target(name, service, namedOrTagged) {
        this.name = new queryable_string_1.default(name);
        this.service = new queryable_string_1.default(service);
        this.metadata = new Array();
        var metadataItem = null;
        if (typeof namedOrTagged === "string") {
            metadataItem = new metadata_1.default("named", namedOrTagged);
        }
        else if (namedOrTagged instanceof metadata_1.default) {
            metadataItem = namedOrTagged;
        }
        if (metadataItem !== null) {
            this.metadata.push(metadataItem);
        }
    }
    Target.prototype.isArray = function () {
        return (this.service.value().indexOf("[]") !== -1);
    };
    Target.prototype.isNamed = function () {
        for (var i = 0; i < this.metadata.length; i++) {
            var m = this.metadata[i];
            if (m.key === "named") {
                return true;
            }
        }
        return false;
    };
    Target.prototype.isTagged = function () {
        for (var i = 0; i < this.metadata.length; i++) {
            var m = this.metadata[i];
            if (m.key !== "named") {
                return true;
            }
        }
        return false;
    };
    Target.prototype.matchesName = function (name) {
        for (var i = 0; i < this.metadata.length; i++) {
            var m = this.metadata[i];
            if (m.key === "named" && m.value === name) {
                return true;
            }
        }
        return false;
    };
    Target.prototype.matchesTag = function (metadata) {
        for (var i = 0; i < this.metadata.length; i++) {
            var m = this.metadata[i];
            if (m.key === metadata.key && m.value === metadata.value) {
                return true;
            }
        }
        return false;
    };
    return Target;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Target;
